'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _UI = require('./UI');

var _UI2 = _interopRequireDefault(_UI);

var TEMPLATES_PATH = _path2['default'].resolve(__dirname, '..', 'templates');

var PlayerGenerator = (function () {
  function PlayerGenerator(profile, level) {
    _classCallCheck(this, PlayerGenerator);

    this._profile = profile;
    this._level = level;
  }

  _createClass(PlayerGenerator, [{
    key: 'generate',
    value: function generate() {
      return _bluebird2['default'].join(this._generatePlayer(), this._generateReadme());
    }
  }, {
    key: '_generatePlayer',
    value: function _generatePlayer() {
      var _this = this;

      if (this._profile.levelNumber === 1) {
        return _fsExtra2['default'].ensureDirAsync(this._profile.playerPath).then(function () {
          return _fsExtra2['default'].copyAsync(_path2['default'].join(TEMPLATES_PATH, 'Player.js'), _path2['default'].join(_this._profile.playerPath, 'Player.js'));
        });
      }

      return _bluebird2['default'].resolve();
    }
  }, {
    key: '_generateReadme',
    value: function _generateReadme() {
      var _this2 = this;

      return this._readTemplate(_path2['default'].join(TEMPLATES_PATH, 'README.ejs')).then(function (renderedReadme) {
        return _fsExtra2['default'].writeFileAsync(_path2['default'].join(_this2._profile.playerPath, 'README'), renderedReadme);
      });
    }
  }, {
    key: '_readTemplate',
    value: function _readTemplate(templatePath) {
      var level = Object.assign({}, this._level, {
        number: this._profile.levelNumber,
        floorMap: this._getFloorMap(),
        warriorAbilities: {
          existent: this._profile.abilities,
          'new': this._level.warrior.abilities
        },
        units: this._getUniqueUnits()
      });
      return _fsExtra2['default'].readFileAsync(templatePath, 'utf8').then(function (template) {
        return _bluebird2['default'].resolve(_ejs2['default'].render(template, { level: level }));
      });
    }
  }, {
    key: '_getFloorMap',
    value: function _getFloorMap() {
      var _level$size = this._level.size;
      var width = _level$size.width;
      var height = _level$size.height;

      var stairsLocation = [this._level.stairs.x, this._level.stairs.y];
      var units = this._level.units.concat(Object.assign({}, this._level.warrior, { type: 'warrior' })).map(function (unit) {
        return {
          type: unit.type,
          position: {
            x: unit.x,
            y: unit.y,
            facing: unit.facing
          }
        };
      });
      return _UI2['default'].getFloorCharacter(width, height, stairsLocation, units, false);
    }
  }, {
    key: '_getUniqueUnits',
    value: function _getUniqueUnits() {
      var uniqueUnits = {};
      this._level.units.forEach(function (unit) {
        if (!Object.keys(uniqueUnits).includes(unit.type)) {
          uniqueUnits[unit.type] = _UI2['default'].getUnitCharacter(unit.type);
        }
      });
      var warriorName = this._profile.warriorName;
      uniqueUnits[warriorName] = _UI2['default'].getUnitCharacter('warrior');
      return uniqueUnits;
    }
  }]);

  return PlayerGenerator;
})();

exports['default'] = PlayerGenerator;
module.exports = exports['default'];