'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _Game = require('./Game');

var _Game2 = _interopRequireDefault(_Game);

var Runner = (function () {
  function Runner(args, stdin, stdout) {
    _classCallCheck(this, Runner);

    this._args = args;
    this._stdin = stdin;
    this._stdout = stdout;
  }

  _createClass(Runner, [{
    key: 'run',
    value: function run() {
      _Config2['default'].inStream = this._stdin;
      _Config2['default'].outStream = this._stdout;
      this._parseOptions();
      new _Game2['default']().start();
    }
  }, {
    key: '_parseOptions',
    value: function _parseOptions() {
      var argv = _yargs2['default'].usage('Usage: $0 [options]').options({
        d: {
          alias: 'directory',
          describe: 'Run under given directory'
        },
        l: {
          alias: 'level',
          describe: 'Practice level on epic'
        },
        s: {
          alias: 'skip',
          describe: 'Skip user input'
        },
        t: {
          alias: 'time',
          describe: 'Delay each turn by seconds'
        }
      }).help('help', 'Show this message').parse(this._args);

      if (argv.directory) {
        _Config2['default'].pathPrefix = argv.directory;
      }

      if (argv.level) {
        _Config2['default'].practiceLevel = Number.parseInt(argv.level, 10);
      }

      if (argv.skip) {
        _Config2['default'].skipInput = argv.skip;
      }

      if (argv.time) {
        _Config2['default'].delay = Number.parseFloat(argv.time);
      }
    }
  }]);

  return Runner;
})();

exports['default'] = Runner;
module.exports = exports['default'];